<?php defined('_JEXEC' ) or die('Direct Access to this location is not allowed.' );
/**
*	gAvatar 0.4.4
*	by geminorum.ir
*
*	4:05 PM 7/13/2010
*	
*/ 

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.filesystem.file' );
jimport( 'joomla.error.profiler' );
require_once( JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php' );

$mainframe->registerEvent( 'onPrepareAvatar', 'gAvatarCommentsAvatar' );
$mainframe->registerEvent( 'onPrepareAvatars', 'gAvatarCommentsAvatars' );

class plgContentgAvatar extends JPlugin 
{
	function plgContentgAvatar( &$subject, $config ) 
	{
		$plugin = & JPluginHelper::getPlugin( 'content', 'gavatar' );
		$this->_params = new JParameter( $plugin->params );
		$this->_debug = ( ( $this->_params->get( 'debug', '0' ) == '0' ) ? false : true );
		
		parent::__construct( $subject, $config );
	}
	
	function onBeforeDisplayContent( &$article, &$params, $limitstart )
	{
		if ( $this->_debug ) $profiler = new JProfiler();
		
		if ( !$params || $params->get( 'itemK2Plugins' ) !== '' || $params->get( 'hide_author' ) == 1 || ($params->get( 'author_param' ) && !$params->get( 'show_author' ) ) ) return;
		
		$view = JRequest::getCmd( 'view' );
		if ( gAvatar::checkArticle( $this->_params, $view, $article, $params ) )
		{
			$gavatar =& gAvatar::getInstance( $article->created_by, $article->created_by_alias, $this->_params );
			$avatar = $gavatar->getAvatar( $view, $article );
			
			if ( $this->_debug ) echo JUtility::dump( $avatar );
			
			$mode = gAvatar::getDisplayMode( $this->_params, $article );
			switch ( $mode )
			{
				case 'advance' :
				{
					$article->avatar = $avatar;
					if ( $this->_debug ) echo $profiler->mark( 'gAvatar' );
					return;
				}
				case 'header' :
				case 'side' :
				{
					$table = $gavatar->drawTable( $mode, $avatar, $article, $params );
					if ( $this->_debug ) echo JUtility::dump( $table );
					$article->text = $table['before'] . $article->text . $table['after'];
					if ( $this->_debug ) echo $profiler->mark( 'gAvatar' );
					return;
				} 
				default :
				case 'float' : 
				{
					$article->text = $gavatar->drawFloatImage( $avatar ) . $article->text;
					if ( $this->_debug ) echo $profiler->mark( 'gAvatar' );
					return;
				}
			}
		}
	}
	
	
}
class gAvatar extends JObject
{
	var $_userid = 0;
	var $_username = null;
	var $_email = false;
	var $_fullname = null;
	var $_profile = false;
	
	var $_local = false;
	var $_other = false;
	var $_remote = false;
	var $_default = false;
	
	var $_params = null;
	var $_addstyle = true;
	
	var $_authors_section = 0;
	
	function __construct( $username, $userid, $params )
	{
		$mainframe = JFactory::getApplication();
		$db = & JFactory::getDBO();
		$uri =& JURI::getInstance();
		$base = $uri->toString( array( 'scheme', 'host', 'port' ) );
		$user =& JFactory::getUser( $userid );		
		
		$this->_params = $params;
		
		$this->_local = $this->_getImage( $username, $this->_params->get( 'avatar_path', 'images/avatars' ) );
		
		switch ( $params->get( 'integrate', 'nobody' ) )
		{
			case 'gauthor' : 
			{
				$this->_setgAuthor( $username );
			} 
			break;
	
			case 'cb' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
			
				if ( JComponentHelper::isEnabled( 'com_comprofiler', true ) ) 
				{
				
					if ( !isset( $GLOBALS['cbprofileitemid'] ) ) 
					{
						$db->setQuery( "SELECT id FROM #__menu WHERE link = 'index.php?option=com_comprofiler' AND published=1" );
						$item_id = $db->loadResult();

						if ( !$item_id ) 
						{
							$db->setQuery( "SELECT id FROM #__menu WHERE link = 'index.php?option=com_comprofiler&task=userslist' AND published=1" );
							$item_id = $db->loadResult();
						}
						$GLOBALS['cbprofileitemid'] = $item_id;
					} 
					else 
					{
						$item_id = $GLOBALS['cbprofileitemid'];
					}
				
					$db->setQuery( 'SELECT avatar FROM #__comprofiler WHERE user_id = ' . $userid, 0, 1 );
					$result = $db->loadResult();
					if ( $result && JFile::exists( JPATH_BASE . DS . 'images' . DS . 'comprofiler' . DS . $result ) )
					{
						$this->_other = 'images' . DS . 'comprofiler' . DS . $result;
					}
					$this->_profile = $base . JRoute::_( 'index.php?option=com_comprofiler&task=userProfile&user=' . $userid . ( $item_id == 0 ? '' : '&Itemid=' . $item_id ) );
				}
			} 
			break;

			case 'cbe' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
			
				if ( JComponentHelper::isEnabled( 'com_cbe', true ) ) {
					$db->setQuery( 'SELECT avatar FROM #__cbe WHERE user_id = ' . $userid, 0, 1 );
					$result = $db->loadResult();
					if ( $result && JFile::exists( JPATH_BASE . DS . 'images' . DS . 'cbe' . DS . $result ) ) {
						$this->_other = 'images' . DS . 'cbe' . DS . $result;
					}
					$this->_profile = $base . JRoute::_( 'index.php?option=com_cbe&task=userProfile&user=' . $userid );
				}
			}
			break;

            case 'kunena' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;

				if ( JComponentHelper::isEnabled( 'com_kunena' , true ) ) {
					$db->setQuery( 'SELECT avatar FROM #__fb_users WHERE userid = ' . $userid, 0, 1 );
					$result = $db->loadResult();
					if ( $result && JFile::exists( JPATH_BASE . DS . 'images' . DS . 'fbfiles' . DS . 'avatars' . DS . $result ) ) {
						$this->_other = 'images' . DS . 'fbfiles' . DS . 'avatars' . DS . $result;
					}
					$this->_profile = $base . JRoute::_( 'index.php?option=com_kunena&func=fbprofile&userid=' . $userid );
				}
			}
			break;

			case 'agora' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
				
				if ( JComponentHelper::isEnabled( 'com_agora', true ) ) {
					$db->setQuery( 'SELECT conf_value FROM #__agora_config WHERE conf_name = o_avatars_dir', 0, 1 );
					$result = $db->loadResult();
					echo $result;
					$agora_avatar_directory = ( $result ? $result : 'components' . DS . 'com_agora' . DS . 'img' . DS . 'pre_avatars' );
					$db->setQuery( 'SELECT id FROM #__agora_users WHERE jos_id = ' . $userid . ' AND use_avatar = 1', 0, 1 );
					$result = $db->loadResult();
					if ( $result ) {
						$this->_other = $this->_getImage( $result, $agora_avatar_directory );
					}
					$this->_profile = $base . JRoute::_( 'index.php?option=com_agora&task=profile&page=preview&user_id=' . $result );
				}
			}
			break;

			case 'js' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
			
				if ( JComponentHelper::isEnabled( 'com_community', true ) ) 
				{
					include_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' );
					$js_user = & CFactory::getUser( $userid );
					$this->_other = $this->_getPath( $js_user->getThumbAvatar() );
					$this->_fullname = $js_user->getDisplayName();
					$this->_profile = $base . CRoute::_( 'index.php?option=com_community&view=profile&userid=' . $userid );
				}
			}
			break;

			
			// It's for facebook and I can't test it.
			// because I'm living in a forbidden country!
			case 'myapi' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;

				if ( JComponentHelper::isEnabled( 'com_myapi', true ) && file_exists( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_myapi' . DS . 'models' . DS . 'facebook.php' ) ) 
				{
					require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_myapi' . DS . 'models' . DS . 'facebook.php' );
					$facebookmodel = new myapiModelfacebook;
					$details = $facebookmodel->getUserDetails( $facebookmodel->getUid( $userid ) );
					if ( $details )
					{
						$this->_fullname = $details['first_name'] . ' ' . $details['last_name'];
						$this->_remote = $details['pic_square'];
						//TODO : check if it always correct.
						$this->_profile = 'http://www.facebook.com/' . $details['username'];
					}
				}
			}
			break;

			case 'k2' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
			
				if ( JComponentHelper::isEnabled( 'com_k2', true ) )
				{
					$db->setQuery( 'SELECT userid, image AS avatar FROM #__k2_users WHERE userid = ' . $userid );
					//$result = $db->loadObjectList( 'userid' );
					$result = $db->loadObject();
					if ( $result )
					{
						require_once ( JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'route' . '.php' );
						$this->_profile = $base . JRoute::_( K2HelperRoute::getUserRoute( $userid ) );
					
						if ( file_exists( JPATH_SITE . DS . 'media' . DS . 'k2' . DS . 'users' . DS . $result->avatar ) ) 
						{
							$this->_other = 'media' . DS . 'k2' . DS . 'users' . DS . $result->avatar;
						}
					}
				}
			}
			break;
			
			case 'ccboard' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
			
				if ( JComponentHelper::isEnabled( 'com_ccboard', true ) )
				{			
			        $db->setQuery( 'SELECT user_id, avatar FROM #__ccb_users WHERE user_id = ' . $userid );
			        $result = $db->loadObject();
					if ( $result && JFile::exists( JPATH_SITE . DS . 'components' . DS . 'com_ccboard' . DS . 'assets' . DS . 'avatar' . DS . $result->avatar ) )
					{
						$this->_other = 'components' . DS . 'com_ccboard' . DS . 'assets' . DS . 'avatar' . DS . $result->avatar;
					}
					$this->_profile =  $base . JRoute::_( 'index.php?option=com_ccboard&view=myprofile&cid=' . $userid );
				}
			}
			break;

			case 'gravatar' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;

				$profile = unserialize( file_get_contents( 'http://www.gravatar.com/' . md5( strtolower( trim( $this->_email ) ) ) . '.php' ) );
				if ( is_array( $profile ) && isset( $profile['entry'] ) ) 
				{
					$this->_fullname = $profile['entry'][0]['displayName'];
					$this->_profile = $profile['entry'][0]['profileUrl'];
					$size = explode( 'x', $this->_params->get( 'size_profile', '100x100' ) );
					$this->_remote = $profile['entry'][0]['thumbnailUrl'] . '?s=' . $size[0];
				}
			}
			break;
			
			default :
			case 'nobody' :
			{
				$this->_fullname = $user->get( 'name' );
				$this->_email = $user->get( 'email' );
				$this->_userid = $userid;
				$this->_username = $username;
				 
				list( $this->_profile , $this->_other ) = $this->_getContact( $userid , JComponentHelper::isEnabled( 'com_qcontacts', true ) ? 'qcontacts' : 'contact' );
				$this->_profile = $base . $this->_profile;
				if ($this->_params->get('image_priority', 0)) list( $this->_other, $this->_local ) = array( $this->_local, $this->_other );
				
			}
		}
		
		
		
		$template = $mainframe->getTemplate();
		
		if ( JPath::find( JPATH_SITE . DS . 'templates' . DS . $template . DS . 'images', 'avatar.png' ) )
		{
			$this->_default = 'templates' . DS . $template . DS . 'images' . DS . 'avatar.png';
		} else {
			$this->_default = 'plugins' . DS . 'content' . DS . 'gavatar' . DS . 'avatar.png';
		}
			
		$this->_addstyle = $this->_params->get( 'add_style' ) ? true : false;
	}
	
	function &getInstance( $userid, $alias = '', $loaded_params = null )
	{
		static $instances;
		static $params;
		
		if ( is_null( $loaded_params ) )
		{
			$plugin = JPluginHelper::getPlugin( 'content', 'gavatar' );
			$params = new JParameter( $plugin->params );
		}
		else if ( !isset( $params ) ) 
		{
			$params = $loaded_params;
		}

		if ( !isset( $instances ) ) 
		{
			$instances = array();
		}

		if ( $alias != '' && $params->get( 'integrate', '0' ) == 'gauthor' && JString::strpos( $alias, 'a=' ) )
		{
			$usernames = explode( ',', JString::str_ireplace( array( '{', 'ga=', '}', '&t', '&e' ), '', $alias ) );
			$username = $usernames[0];
		}
		else
		{
			$user =& JFactory::getUser( $userid );
			$username = $user->get( 'username' );
			
		}
	
		if ( empty( $instances[$username] ) ) 
		{
			$gavatar = new gAvatar( $username, $userid, $params );
			$instances[$username] = $gavatar;
		}
		
		return $instances[$username];
	}
	
	function _setgAuthor( $username )
	{
		$this->_username = $username;
		if( JPluginHelper::isEnabled( 'system', 'gauthor' ) )
		{
			/**
			$gauthor_plugin = & JPluginHelper::getPlugin( 'system', 'gauthor' );
			$gauthor_params = new JParameter( $gauthor_plugin->params );
			$this->_authors_section = $gauthor_params->get( 'authors_section', 0 );
			$gauthor =& gAuthor::getInstance( $gauthor_params );
			*/
			$gauthor =& gAuthor::getInstance();
			$this->_authors_section = $gauthor->getAuthorsSection();
			$author = $gauthor->getAuthorByUsername( $this->_username );
			if ( $author )
			{
				$this->_fullname = $author['fullname'];
				$this->_email = $author['email'];
				$this->_profile = $author['profile'];
				$this->_userid = $author['user_id'];
			}
		}
	}
	
	function _getImage( $username, $path )
	{
		$path = JPath::clean( $path );
		foreach ( array( 'png', 'jpg', 'jpeg', 'gif' ) as $ext ) 
		{
			if ( JPath::find( $path, $username . '.' . $ext ) )
			{
				return $path . DS . $username . '.' . $ext;
			}
		}
		return false;
	}
	
	function _getPath( $url )
	{
		return JPath::clean( JString::str_ireplace( JURI::base(), '', $url ) );
	}
	
	function _getContact( $userid, $component = 'contact' )
	{
		$db =& JFactory::getDBO();
		$query = 'SELECT a.*, '
				.' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '
				.' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(\':\', cc.id, cc.alias) ELSE cc.id END AS catslug '
				.' FROM ' . $db->nameQuote( '#__' . $component . '_details' ) . ' AS a'
				.' INNER JOIN #__categories AS cc on cc.id = a.catid'
				.' WHERE user_id = ' . $userid
				.' AND a.published = 1'
				.' AND cc.published = 1';
		$db->setQuery( $query, 0, 1 );
		$contact = $db->loadObject();
		return ( $contact ? array( JRoute::_( 'index.php?option=com_' . $component . '&view=contact&id=' . $contact->slug . '&catid=' . $contact->catslug ), 'images' . DS . 'stories' . DS . $contact->image ) : array( false, false ) );
	}
	
	function checkArticle( $params, $view, &$article, &$article_params )
	{
		if ( !JString::strpos( $article->text, '{gavatar off}' ) === false ) 
		{
			$article->text = JString::str_ireplace( '{gavatar off}', '', $article->text );
			return false;
		}
		if ( $view == 'frontpage' && $params->get( 'on_front', '1' ) == '0' ) return false;
		if ( ( $view == 'category' || $view == 'section' ) && $params->get( 'on_cat', '1' ) == '0' ) return false;
		if ( $view == 'article' && $params->get( 'on_article', '1' ) == '0' ) return false;
		
		if ( $params->get( 'exception', 0 ) ) 
		{
			$by = $params->get( 'exception_by', 'sectionid' );
			$id = $article->$by;

            $act = $params->get( 'exception_act', '0' );
            
			if ( $act && $params->get( 'exception_uncat', '1' ) && $article->sectionid == 0 ) return false;
			
			$list = explode( ',', $params->get( 'exception_list' ) );
			
			if ( !$act ) {
				foreach ( $list as $ex ) {
					if ( $ex == $id ) return false;
				} return true;
			} else {
				foreach ( $list as $ex ) {
					if ( $ex == $id ) return true;
				} return false;
			}
		}
		return true;
	}
	
	function getImageTag( $avatar, $linked = false )
	{
		$tag = '<img src="' . $avatar['src'] . '" alt="' . $avatar['fullname'] . '" width="' . $avatar['width'] . '" height="' . $avatar['height'] . '"/>';
		return $linked ? '<a href="' . $avatar['profile'] . '" title="' . $avatar['fullname'] . '" >' . $tag . '</a>' : $tag;
	}
	
	function getDisplayMode( $params, &$article )
	{
		$regex = '/{(gavatar)\s*(.*?)}/i';
		$display_mode = $params->get( 'display_mode', 'float' );
		preg_match_all( $regex, $article->text, $matches );
		if ( count($matches[0] ) ){
			$display_mode = str_replace( 'gavatar mode=', '', $matches[0][0] );
			$display_mode = str_replace( '{', '', $display_mode );
			$display_mode = str_replace( '}', '', $display_mode );
			$display_mode = trim( $display_mode );
		}
		$article->text = preg_replace( $regex, '', $article->text );
		return $display_mode;
	}
	
	function _getGravatar( $size )
	{
		if ( is_null( $this->_email ) ) return $this->_getURL( $this->_default );
		//return $this->_default;
		return 'http://www.gravatar.com/avatar/' . md5( strtolower( trim( $this->_email ) ) ) . '.jpg'
			  .'?d=' . urlencode( $this->_getURL( $this->_default ) )
			  .'&s=' . $size 
			  .'&r=' . $this->_params->get( 'rating', 'g' );
	}
	
	function getAvatar( $view, $article = null )
	{
		if ( is_null( $article ) )
		{
			$size = $this->_getSize( $view );
			list( $width, $height ) = $this->_calSize( $size );
		}
		else 
		{
			$size = $this->_getSize( $view, $article->sectionid );
			list( $width, $height ) = $this->_calSize( $size );

			if ( $this->_params->get( 'integrate', 'nobody' ) == 'gauthor' && ( $size == 'profile' || ( $size == 'default' && $article->sectionid == $this->_authors_section ) ) )
			{
				$this->_setgAuthor( $article->alias );
				$this->_local = $this->_getImage( $article->alias, $this->_params->get( 'avatar_path', 'images/avatars' ) );
				$this->_fullname = false;
			}
		}
		
		if ( $this->_params->get( 'cache', 0 ) )
		{
			$filename = $this->_username . '_' . $size . '_' . $width . 'x' . $height;
			
			$cache_directory = JPATH_CACHE . DS . 'avatars';
			$cache_uri = JURI::base() . 'cache/avatars/';

			if ( !JFolder::exists( $cache_directory ) ) 
			{
				if ( !JFolder::create( $cache_directory ) )
				{
					$cache_directory = JPATH_CACHE;
					$cache_uri = JURI::base() . 'cache/';
				}
			}
			
			$cache_path = $this->_getImage( $filename, $cache_directory );
			if ( !$cache_path ) {
				switch ( $this->_params->get( 'avatar_mode', '1' ) ) 
				{
					case '0':
						if ( $this->_email ){
							$path = $this->_storeRemoteAvatar( $cache_directory, $filename, $this->_getGravatar( width ) );
						} else {
							$path = JPATH_ROOT . DS . $this->_default;
						}
					break;
					default:
					case '1':
						$path = ( $this->_remote ? $this->_remote : ( $this->_other ? $this->_other : ( $this->_local ? $this->_local : $this->_default ) ) );
						if ( $path == $this->_remote )
						{
							$path = $this->_storeRemoteAvatar( $cache_directory, $filename, $this->_remote );
						}
						else if ( $path == $this->_default )
						{
							if ( $this->_email ) 
							{
								$path = $this->_storeRemoteAvatar( $cache_directory, $filename, $this->_getGravatar( $width ) );
							} 
							else 
							{
								$path = JPATH_ROOT . DS . $this->_default;
							}
						}
						else 
						{
							$path = JPATH_ROOT . DS . $path;
						}
					break;
					case '2':
						$path = ( $this->_remote ? $this->_remote : ( $this->_other ? $this->_other : ( $this->_local ? $this->_local : $this->_default ) ) );
						if ( $path == $this->_remote )
						{
							$path = $this->_storeRemoteAvatar( $cache_directory, $filename, $this->_remote );
						}
						else
						{
							$path = JPATH_ROOT . DS . $path;
						}
					break;
				}
				//originally form SmartResizer by igort : lot-studio.ru
				require_once( dirname( __FILE__ ) . DS . 'gavatar' . DS . 'smartimagehandler.php' );
				$image = new smartimgRedim( $this->_params->get( 'debug', 0 ), $this->_params->get( 'improve', false ), JPATH_CACHE );
				$image->loadImage( $path );
				$image->redimToSize( $width, $height, true );
				$image->saveImage( $cache_directory . DS . $filename . '.' . JFile::getExt( $path ), $this->_params->get( 'quality', '90' ) );				
			}
			$url = $cache_uri . $filename . '.' . JFile::getExt( ( isset( $path ) ? $path : $cache_path ) );
			return array( 'src' => $url, 'width' => $width, 'height' => $height, 'fullname' => $this->_fullname, 'profile' => $this->_profile );
		} 

		switch ( $this->_params->get( 'avatar_mode', '1' ) ) 
		{
			case '0':
				$url = ( $this->_email ? JFilterOutput::linkXHTMLSafe( $this->_getGravatar( $width ) ) : $this->_getURL( $this->_default ) );
			break;
			default:
			case '1':
				$url = ( $this->_remote ? JFilterOutput::linkXHTMLSafe( $this->_remote ) : ( $this->_other ? $this->_getURL( $this->_other ) : ( $this->_local ? $this->_getURL($this->_local) : ($this->_email ? JFilterOutput::linkXHTMLSafe($this->_getGravatar($width)) : $this->_getURL($this->_default)))));
			break;
			case '2':
				$url = ( $this->_remote ? JFilterOutput::linkXHTMLSafe( $this->_remote ) : ( $this->_other ? $this->_getURL( $this->_other ) : ( $this->_local ? $this->_getURL($this->_local) : $this->_getURL($this->_default))));
			break;
		}
		return array('src'=>$url, 'width'=>$width, 'height'=>$height, 'fullname'=>$this->_fullname, 'profile'=>$this->_profile);
	}

	// originally from timthumb by Tim McDaniels : code.google.com/p/timthumb
	function _storeRemoteAvatar($path, $filename, $url)
	{
		$local_filepath = $path.DS.'remote_'.$filename.'.jpg';
		if (!JFile::exists($local_filepath)) 
		{
			if (function_exists('curl_init')) 
			{
				$fh = fopen($local_filepath, 'w');
				$ch = curl_init($url);
				
				curl_setopt($ch, CURLOPT_URL, $url);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
				curl_setopt($ch, CURLOPT_FILE, $fh);
				
				if (curl_exec($ch) === FALSE) 
				{
					if (file_exists($local_filepath)) 
					{
						unlink($local_filepath);
					}
					JError::raiseWarning(21, 'error reading file ' . $url . ' from remote host: ' . curl_error($ch));
					return false;
				}
				
				curl_close($ch);
				fclose($fh);
			} 
			else 
			{
				if (!$img = file_get_contents($url)) 
				{
					JError::raiseWarning(21, 'remote file for ' . $url . ' can not be accessed. It is likely that the file permissions are restricted');
					return false;
				}
				
				if (file_put_contents($local_filepath, $img) == FALSE) 
				{
					JError::raiseWarning(21, 'error writing temporary file');
					return false;
				}
			}
			if (!file_exists($local_filepath)) 
			{
				JError::raiseWarning(21, 'local file for ' . $url . ' can not be created');
				return false;
			}
		}
		return $local_filepath;
	}
	
	function _getURL($path)
	{	
		return ($path ? JURI::base().str_replace(DS, '/' ,$path) : false);
	}
		
	function _getSize($view, $sectionid = 0)
	{
		if ($view == 'comments') return 'comment';
		if ($view == 'article' && $sectionid == $this->_authors_section) return 'profile';
		if ($view == 'article') return 'article';
		return 'default';
	}
	
	function _calSize($size)
	{
		switch ($size)
		{
			case 'comment' : return explode('x', $this->_params->get('size_comment', '32x32')); //32
			case 'profile' : return explode('x', $this->_params->get('size_profile', '100x100')); //100
			case 'article' : return explode('x', $this->_params->get('size_article', '80x80')); //80
			default: return explode('x', $this->_params->get('size_default', '60x60')); //60
		}
	}
	
	function drawFloatImage($avatar)
	{
		if ($this->_addstyle) JHTML::stylesheet('avatar.float.css', 'plugins/content/gavatar/');
		
		$html = '<img class="avatar_'.$this->_params->get('float', 'right').'"' . ' src="'.$avatar['src'].'"' . ' alt="'.$avatar['fullname'].'"' . ' style="border:'.$this->_params->get('border','none').'; width:'.$avatar['width'].'px; height:'.$avatar['height'].'px;"' . ' />';
		if ($avatar['profile']) $html = '<a href="'.$avatar['profile'].'"'. ' alt="'.$avatar['fullname'].'" >'.$html.'</a>';

		return $html;
	}
	
	function drawTable($type, $avatar, &$article, &$params)
	{
		$header = array();
		
		$header['avatar'] = '<img src="'.$avatar['src'].'" style="border:'.$this->_params->get('border','none').'; width:'.$avatar['width'].'px; height:'.$avatar['height'].'px;" alt="'.$avatar['fullname'].'"/>';
		
		if ($avatar['profile']) $header['avatar'] = '<a href="'.$avatar['profile'].'" title="'.$avatar['fullname'].'">'.$header['avatar'].'</a>';

		$header['suffix'] = $params->get('pageclass_sfx');
		
		$header['float'] = $this->_params->get('float', 'right');
		
		if ($params->get('show_create_date')) 
		{
			$header['date'] = JHTML::_('date', $article->created, JText::_('DATE_FORMAT_LC2'));
			$params->set('show_create_date', '0');
		} 
		else 
		{
			$header['date'] = false;
		}
		
		if ($avatar['fullname'] !== false)
		{
			if ($params->get('show_author') && ($article->author != ""))
			{
				JPlugin::loadLanguage('plg_content_gavatar', JPATH_ADMINISTRATOR);
				if ($type == 'side') 
				{
					$header['author'] = JText::sprintf('BY', ($article->created_by_alias ? $article->created_by_alias : $article->author));
				}
				else if ($type == 'header') 
				{
					$header['author'] = JText::sprintf('WRITTEN BY', ($article->created_by_alias ? $article->created_by_alias : $article->author));
				}
				$params->set('show_author', '0');
			} 
			else 
			{
				$header['author'] = false;
			}
		}
		else
		{
			$header['author'] = false;
		}
		
		if ($params->get('show_title'))
		{
			if ($params->get('link_titles') && $article->readmore_link != '') 
			{
				$header['title'] = '<a href="'.$article->readmore_link.'" class="contentpagetitle'.$header['suffix'].'" >'.$article->title.'</a>';
			} 
			else 
			{
				$header['title'] = htmlspecialchars($article->title, ENT_QUOTES, 'UTF-8');
			}
			
			$params->set('show_title', '0');
		}
		else
		{
			$header['title'] = false;
		}
		
		if ($params->get('show_pdf_icon')) 
		{
			$header['pdf'] = JHTML::_('icon.pdf', $article, $params, true);
			$params->set('show_pdf_icon', '0');
		} 
		else
		{
			$header['pdf'] = false;
		}
		
		if ($params->get('show_print_icon')) 
		{
			$header['print'] = JHTML::_('icon.print_popup', $article, $params, true);
			$params->set('show_print_icon', '0');
		}
		else
		{
			$header['print'] = false;
		}
		
		if ($params->get('show_email_icon')) 
		{
			$header['email'] = JHTML::_('icon.email', $article, $params, true);
			$params->set('show_email_icon', '0');
		} 
		else 
		{
			$header['email'] = false;
		}
		
		if ($params->get('show_section') && $article->sectionid && isset($article->section)) 
		{
			if ($params->get('link_section')) 
			{
				$header['section'] = '<a href="'.JRoute::_(ContentHelperRoute::getSectionRoute($article->sectionid)).'">'.$article->section.'</a>';
			} 
			else 
			{
				$header['section'] = $article->section;
			}
			
			$params->set('show_section', '0');
		} 
		else 
		{
			$header['section'] = false;
		}
		
		if ($params->get('show_category') && $article->catid) 
		{
			if ($params->get('link_category')) 
			{
				$header['cat'] = '<a href="'.JRoute::_(ContentHelperRoute::getCategoryRoute($article->catslug, $article->sectionid)).'">'.$article->category.'</a>';
			} 
			else 
			{
				$header['cat'] = $article->category;
			}
			
			$params->set('show_category', '0');
		}
		else
		{
			$header['cat'] = false;
		}

		if ($this->_addstyle) JHTML::stylesheet('avatar.html.css', 'plugins/content/gavatar/');
	
		switch ($type){
			case 'side' : {
				list($before, $after) = $this->_drawSideTable($header, $avatar['width'], $avatar['height']);
			}	
			break;
		
			case 'header' :
			{
				$before = $this->_drawHeaderTable($header, $avatar['width'], $avatar['height']);
				$after = '';
			}
		}
		
		if (isset($article->toc))
		{
			$before .= $article->toc;
			unset($article->toc);
		}
		
		return array('before' => $before, 'after' => $after);
	}
	
	function _drawSideTable($header, $width, $height)
	{
		$before = "<table class=\"avatar_side\" style=\"width:100%; border:none;\"><tr>\n";
		
		if ($header['float'] == 'left') {
			$before .= '<td style="vertical-align:text-top;"><table style="width:100%; border:none; text-align:center;"><tr width="'.$width.'" height="'.$height.'" rowspan="5" class="avatar"><td>'.$header['avatar']."</td></tr>\n";
			if ($header['author']) $before .= '<tr style="width:'.$width.';" ><td><span class="small">'.$header['author']."</span></td></tr>\n";
			$before .= '</table></td>';
		}
		
		$before .= "<td><table style=\"width:100%; vertical-align:middle;\"><tr><td><table><tr>\n";
		if ($header['title']) $before .= '<td class="contentheading'.$header['suffix'].'" >'.$header['title']."</td>\n";
		if ($header['pdf']) $before .= '<td align="right" class="buttonheading">'.$header['pdf']."</td>\n";
		if ($header['print']) $before .= '<td align="right" class="buttonheading">'.$header['print']."</td>\n";
		if ($header['email']) $before .= '<td align="right" class="buttonheading">'.$header['email']."</td>\n";
		$before .= '</tr>';		
		if ($header['section'] || $header['cat']) $before .= "<tr><td>\n";
		if ($header['section']) $before .= '<span class="content_section" >'.$header['section'].'</span>';
		if ($header['section'] && $header['cat']) $before .= ' - ';
		if ($header['cat']) $before .= '<span class="content_category" >'.$header['cat'].'</span>';
		if ($header['section'] || $header['cat']) $before .= "</td></tr>\n";
		if ($header['date']) $before .= '<tr><td class="createdate" >'.$header['date']."</td></tr>\n";

		$before .= '</table></td></tr><tr><td>';
		
		$after = '</td></tr></table></td>';
		if ($header['float'] == 'right') 
		{
			$after .= '<td style="vertical-align:text-top;"><table style="width:100%; border:none; text-align:center;"><tr width="'.$width.'" height="'.$height.'" rowspan="5" class="avatar"><td>'.$header['avatar']."</td></tr>\n";
			if ($header['author']) $after .= '<tr style="width:'.$width.';" ><td><span class="small">'.$header['author']."</span></td></tr>\n";
			$after .= '</table></td>';
		}
		
		$after .= "</tr></table>\n";
		
		return array($before, $after);
	}
	
	function _drawHeaderTable($header, $width, $height)
	{
		$result = '<table class="avatar_header" style="width:100%; border:none; vertical-align:middle;"><tr>';
		if ($header['float'] == 'left') $result .= '<td width="'.$width.'" height="'.$height.'" rowspan="5" class="avatar" >'.$header['avatar'].'</td>';
		$result .= '<td><table style="width:100%; vertical-align:middle;"><tr class="avatar_article">';
		if ($header['title']) $result .= '<td class="contentheading'.$header['suffix'].'" >'.$header['title'].'</td>';
		if ($header['pdf']) $result .= '<td align="right" class="buttonheading">'.$header['pdf'].'</td>';
		if ($header['print']) $result .= '<td align="right" class="buttonheading">'.$header['print'].'</td>';
		if ($header['email']) $result .= '<td align="right" class="buttonheading">'.$header['email'].'</td>';
		$result .= '</tr>';
		if ($header['section'] || $header['cat']) $result .= '<tr><td>';
		if ($header['section']) $result .= '<span class="content_section" >'.$header['section'].'</span>';
		if ($header['section'] && $header['cat']) $result .= ' - ';
		if ($header['cat']) $result .= '<span class="content_category" >'.$header['cat'].'</span>';
		if ($header['section'] || $header['cat']) $result .= '</td></tr>';
		if ($header['date']) $result .= '<tr><td class="createdate" >'.$header['date'].'</td></tr>';
		if ($header['author']) $result .= '<tr><td><span class="small">'.$header['author'].'</span></td></tr>';
		$result .= '</table></td>';
		if ($header['float'] == 'right') $result .= '<td width="'.$width.'" height="'.$height.'" rowspan="5" class="avatar">'.$header['avatar'].'</td>';
		$result .= '</tr></table>';
		
		return $result;
	}
}


/*
 * The following is inspired from DAvatar for JComments by Darkick <http://joomla.darkick.ru>
*/


function gAvatarCommentsAvatar(&$comment)
{
	gAvatarCommentsAvatars(array(&$comment));
}

function gAvatarCommentsAvatars(&$comments)
{
	//Check : Is this necessary? even if JComments called on other than contents?
	//if (JPluginHelper::importPlugin('content', 'gavatar'))
	
	if (JPluginHelper::isEnabled('content', 'gavatar'))
	{
		$avatars = array();

		$plugin = JPluginHelper::getPlugin('content', 'gavatar');
		$params = new JParameter($plugin->params);
		if ($params->get('jcomments', 0))
		{
			foreach ($comments as &$comment)
			{
				if (!isset($avatars[(int)$comment->userid])) 
				{
					$avatars[(int)$comment->userid] =& gAvatar::getInstance((int)$comment->userid, '', $params);
				}
				$avatar = $avatars[(int)$comment->userid]->getAvatar('comments');
				$comment->avatar = $avatars[(int)$comment->userid]->getImageTag($avatar, true);
			}
		}
	}
}